﻿namespace TSLab.Script.Handlers
{
    [HandlerCategory(HandlerCategories.MarketPosition)]
    public abstract class BaseTradeStatisticsHandler<TTradeStatisticsWithKind> : IBaseTradeStatisticsHandler<TTradeStatisticsWithKind>
        where TTradeStatisticsWithKind : IBaseTradeStatisticsWithKind
    {
        public IContext Context { get; set; }

        [HandlerParameter(true, "1", Min = "1", Max = "10", Step = "1")]
        public int CombinePricesCount { get; set; }

        [HandlerParameter(true, "TradesCount", NotOptimized = true)]
        public TradeStatisticsKind Kind { get; set; }

        public abstract TTradeStatisticsWithKind Execute(ISecurity security);
    }
}
