﻿using System.Collections.Generic;
using TSLab.DataSource;

namespace TSLab.Script.Handlers
{
    [HandlerCategory(HandlerCategories.TradeMath)]
    public abstract class FinInfoHandler : IBar2DoubleHandler//, IContextUses
    {
        //public IContext Context { get; set; }

        public IList<double> Execute(ISecurity source)
        {
            return new ConstList<double>(source.Bars.Count, GetValue(source.FinInfo) ?? 0);
        }

        protected abstract double? GetValue(FinInfo finInfo);
    }

    public sealed class BuyCount : FinInfoHandler
    {
        protected override double? GetValue(FinInfo finInfo)
        {
            return finInfo.BuyCount;
        }
    }

    public sealed class SellCount : FinInfoHandler
    {
        protected override double? GetValue(FinInfo finInfo)
        {
            return finInfo.SellCount;
        }
    }
}
