﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace TSLab.Script.Handlers
{
    [HandlerCategory(HandlerCategories.Position)]
    public sealed class HoldSignalForNBars : IOneSourceHandler, IBooleanReturns, IStreamHandler, IBooleanInputs
    {
        [HandlerParameter(true, "0", Min = "0", Max = "10", Step = "1", EditorMin = "0")]
        public int NBars { get; set; }

        public IList<bool> Execute(IList<bool> source)
        {
            if (NBars <= 0 || source.Count <= 1 || source.All(item => item) || source.All(item => !item))
                return source;

            var result = new List<bool>(source);
            for (var i = 0; i < source.Count; i++)
            {
                if (source[i])
                {
                    var jMax = Math.Min(i + NBars, source.Count - 1);
                    for (var j = i + 1; j <= jMax; j++)
                        result[j] = true;
                }
            }
            return result;
        }
    }
}
