﻿#if DEBUG
using System;
using System.Collections.Generic;
using TSLab.Script.CanvasPane;

namespace TSLab.Script.Handlers
{
    [HandlerCategory(HandlerCategories.MarketPosition)]
    [OutputType(TemplateTypes.INTERACTIVESPLINE)]
#if !DEBUG
    [HandlerInvisible]
#endif
    public sealed class InteractiveSeriesHandler : IOneSourceHandler, IStreamHandler, ISecurityInputs
    {
        public InteractiveSeries Execute(ISecurity security)
        {
            var interactiveObjects = new List<InteractiveObject>();
            for (var i = 0; i < 10; i++)
            {
                interactiveObjects.Add(new InteractiveObject { Anchor = new InteractivePointActive(i, i) { Label = i.ToString() } });
            }
            return new InteractiveSeries(interactiveObjects);
        }
    }
}
#endif
