﻿#if DEBUG
namespace TSLab.Script.Handlers
{
    public sealed class LastContractsTradeStatisticsHandler : BaseTradeStatisticsHandler<ILastContractsTradeStatisticsWithKind>, ILastContractsTradeStatisticsHandler
    {
        [HandlerParameter(true, "10000", Min = "10000", Max = "1000000", Step = "10000")]
        public int ContractsCount { get; set; }

        public override ILastContractsTradeStatisticsWithKind Execute(ISecurity security)
        {
            var id = string.Join(".", security.Symbol, security.Interval, CombinePricesCount, ContractsCount);
            var tradeStatistics = Context.GetLastContractsTradeStatistics(id, () => new LastContractsTradeStatistics(security, CombinePricesCount, ContractsCount));
            return new LastContractsTradeStatisticsWithKind(tradeStatistics, Kind);
        }
    }
}
#endif
