﻿#if DEBUG
using TSLab.DataSource;

namespace TSLab.Script.Handlers
{
    public sealed class LastTradeStatisticsHandler : BaseTradeStatisticsHandler<ITradeStatisticsWithKind>, ITradeStatisticsHandler
    {
        [HandlerParameter(true, "1", Min = "1", Max = "365", Step = "1")]
        public int TimeFrame { get; set; }

        [HandlerParameter(true, nameof(TimeFrameUnit.Hour), NotOptimized = true)]
        public TimeFrameUnit TimeFrameUnit { get; set; }

        [HandlerParameter(true, "0", Min = "0", Max = "365", Step = "1")]
        public int TimeFrameShift { get; set; }

        [HandlerParameter(true, nameof(TimeFrameUnit.Hour), NotOptimized = true)]
        public TimeFrameUnit TimeFrameShiftUnit { get; set; }

        public override ITradeStatisticsWithKind Execute(ISecurity security)
        {
            var timeFrame = TimeFrameFactory.Create(TimeFrame, TimeFrameUnit);
            var timeFrameShift = TimeFrameFactory.Create(TimeFrameShift, TimeFrameShiftUnit);
            var id = string.Join(".", security.Symbol, security.Interval, CombinePricesCount, TimeFrame, TimeFrameUnit, TimeFrameShift, TimeFrameShiftUnit);
            var tradeStatistics = Context.GetLastTradeStatistics(id, () => new LastTradeStatistics(security, CombinePricesCount, timeFrame, TimeFrameUnit, timeFrameShift, TimeFrameShiftUnit));
            return new TradeStatisticsWithKind(tradeStatistics, Kind);
        }
    }
}
#endif
